%global __strip %{_mingw32_strip}
%global __objdump %{_mingw32_objdump}
%global _use_internal_dependency_generator 0
%global __find_requires %{_mingw32_findrequires}
%global __find_provides %{_mingw32_findprovides}
%global svnver 1664

%global nativename libgeotiff

Name:      mingw32-%{nativename}
Version:   1.3.0
Release:   0.1.svn%{svnver}%{?dist}
Summary:   GeoTIFF format library
Group:     System Environment/Libraries
License:   MIT
URL:       http://trac.osgeo.org/geotiff/

#svn -r %{svnver} export https://svn.osgeo.org/metacrs/geotiff/trunk/%{nativename}
#cd %{nativename}
#./autogen.sh
# mingw32-configure
#make dist
Source:    %{nativename}-%{version}.tar.gz

Patch0:    %{nativename}-noundefined.patch
BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
BuildArch: noarch

BuildRequires: libtool
BuildRequires: mingw32-filesystem >= 35
BuildRequires: mingw32-gcc
BuildRequires: mingw32-binutils
BuildRequires: mingw32-libtiff
BuildRequires: mingw32-libjpeg
BuildREquires: mingw32-proj
BuildRequires: mingw32-zlib

%description
GeoTIFF represents an effort by over 160 different remote sensing, 
GIS, cartographic, and surveying related companies and organizations 
to establish a TIFF based interchange format for georeferenced 
raster imagery.

%package devel
Summary: Development Libraries for the GeoTIFF file format library
Group: Development/Libraries
Requires: pkgconfig libtiff-devel
Requires: %{name} = %{version}-%{release}

%description devel
The GeoTIFF library provides support for development of geotiff image format.

%prep
%setup -q -n libgeotiff-%{version}
%patch0 -p1

# fix wrongly encoded files from tarball
set +x
for f in `find . -type f` ; do
   if file $f | grep -q ISO-8859 ; then
      set -x
      iconv -f ISO-8859-1 -t UTF-8 $f > ${f}.tmp && \
         mv -f ${f}.tmp $f
      set +x
   fi
   if file $f | grep -q CRLF ; then
      set -x
      sed -i -e 's|\r||g' $f
      set +x
   fi
done
set -x

# remove junks
find . -name ".cvsignore" -exec rm -rf '{}' \;

%build

# disable -g flag removal
sed -i 's| \| sed \"s\/-g \/\/\"||g' configure

# use gcc -shared instead of ld -shared to build with -fstack-protector
sed -i 's|LD_SHARED=@LD_SHARED@|LD_SHARED=@CC@ -shared|' Makefile.in

%{_mingw32_configure} --with-proj --with-jpeg --with-zip

make %{?_smp_mflags}

%install
rm -rf $RPM_BUILD_ROOT
make DESTDIR=$RPM_BUILD_ROOT install

# install pkgconfig file
cat > %{nativename}.pc <<EOF
prefix=%{_mingw32_prefix}
exec_prefix=%{_mingw32_prefix}
libdir=%{_mingw32_libdir}
includedir=%{_mingw32_includedir}/%{name}

Name: %{name}
Description: GeoTIFF file format library
Version: %{version}
Libs: -L\%{_mingw32_libdir} -lgeotiff
Cflags: -I\%{_mingw32_includedir}
EOF

mkdir -p %{buildroot}%{_mingw32_libdir}/pkgconfig/
install -p -m 644 %{nativename}.pc %{buildroot}%{_mingw32_libdir}/pkgconfig/

# Remove unnecessary files
rm $RPM_BUILD_ROOT%{_mingw32_bindir}/*.exe
rm $RPM_BUILD_ROOT%{_mingw32_libdir}/%{nativename}.a
rm $RPM_BUILD_ROOT%{_mingw32_libdir}/*.la

# Remove the empty file
rm $RPM_BUILD_ROOT%{_mingw32_datadir}/epsg_csv/codes.csv

%clean
rm -rf $RPM_BUILD_ROOT

%post -p /sbin/ldconfig
%postun -p /sbin/ldconfig

%files 
%defattr(-,root,root,-)
%doc ChangeLog README
%{_mingw32_bindir}/%{nativename}-1.dll
%{_mingw32_includedir}/*
%{_mingw32_datadir}/*
%{_mingw32_libdir}/%{nativename}.dll.a
%{_mingw32_libdir}/pkgconfig/%{nativename}.pc

%changelog
* Thu Oct 15 2009 David Ludlow <dave@adsllc.com> - 1.3.0-1.svn1664
- Fedora packaging updates

* Wed Sep 9 2009 David Ludlow <dave@adsllc.com> - 1.2.5-4
- Initial creation of mingw32 package
